var path = require('path'),
    assert = require('./assert-ext');

var fileName = module.parent.filename,
    expected = 0,
    testsRan = 0,
    timeout,
    timer;

this.__defineSetter__('expected', function(val) {
    expected = val;
});

exports.assert = assert;

exports.finish = function() {
  clearTimeout(timeout);
  report();
}

assert.on('ranTest', function() {
  ranTests(1);
});

ranTests(0); //do a check now (incase no tests are ran)

function ranTests(number) {
  testsRan += number;
  if (!timer) timer = Date.now();
  clearTimeout(timeout);
  
  timeout = setTimeout(function() {
    report();
  }, 500);
}

function report() {
  function color(text) {
    return (testsRan === expected) ? '\033[32m' + text + '\033[0m' //green
                                   : '\033[31m' + text + '\033[0m'; //red
  }
  var end = Date.now() - timer;
  //report results
  console.log('%s ran %s out of %s tests in %sms', path.basename(fileName), 
    color(testsRan), color(expected), end);
}